<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Contact StructType
 * @subpackage Structs
 */
class Contact extends AbstractStructBase
{
    /**
     * The handle
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $handle;
    /**
     * The civilite
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $civilite;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The firstName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $firstName;
    /**
     * The org
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $org;
    /**
     * The str1
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $str1;
    /**
     * The str2
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $str2;
    /**
     * The str3
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $str3;
    /**
     * The pc
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $pc;
    /**
     * The city
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $city;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $state;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $country;
    /**
     * The langue
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $langue;
    /**
     * The email
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $email;
    /**
     * The tel
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $tel;
    /**
     * The fax
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $fax;
    /**
     * The gsm
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $gsm;
    /**
     * The isowner
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $isowner;
    /**
     * The pwd
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $pwd;
    /**
     * The siret
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $siret;
    /**
     * The metadata
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $metadata;
    /**
     * Constructor method for Contact
     * @uses Contact::setHandle()
     * @uses Contact::setCivilite()
     * @uses Contact::setName()
     * @uses Contact::setFirstName()
     * @uses Contact::setOrg()
     * @uses Contact::setStr1()
     * @uses Contact::setStr2()
     * @uses Contact::setStr3()
     * @uses Contact::setPc()
     * @uses Contact::setCity()
     * @uses Contact::setState()
     * @uses Contact::setCountry()
     * @uses Contact::setLangue()
     * @uses Contact::setEmail()
     * @uses Contact::setTel()
     * @uses Contact::setFax()
     * @uses Contact::setGsm()
     * @uses Contact::setIsowner()
     * @uses Contact::setPwd()
     * @uses Contact::setSiret()
     * @uses Contact::setMetadata()
     * @param string $handle
     * @param string $civilite
     * @param string $name
     * @param string $firstName
     * @param string $org
     * @param string $str1
     * @param string $str2
     * @param string $str3
     * @param string $pc
     * @param string $city
     * @param string $state
     * @param string $country
     * @param string $langue
     * @param string $email
     * @param string $tel
     * @param string $fax
     * @param string $gsm
     * @param bool $isowner
     * @param string $pwd
     * @param string $siret
     * @param string $metadata
     */
    public function __construct($handle = null, $civilite = null, $name = null, $firstName = null, $org = null, $str1 = null, $str2 = null, $str3 = null, $pc = null, $city = null, $state = null, $country = null, $langue = null, $email = null, $tel = null, $fax = null, $gsm = null, $isowner = null, $pwd = null, $siret = null, $metadata = null)
    {
        $this
            ->setHandle($handle)
            ->setCivilite($civilite)
            ->setName($name)
            ->setFirstName($firstName)
            ->setOrg($org)
            ->setStr1($str1)
            ->setStr2($str2)
            ->setStr3($str3)
            ->setPc($pc)
            ->setCity($city)
            ->setState($state)
            ->setCountry($country)
            ->setLangue($langue)
            ->setEmail($email)
            ->setTel($tel)
            ->setFax($fax)
            ->setGsm($gsm)
            ->setIsowner($isowner)
            ->setPwd($pwd)
            ->setSiret($siret)
            ->setMetadata($metadata);
    }
    /**
     * Get handle value
     * @return string|null
     */
    public function getHandle()
    {
        return $this->handle;
    }
    /**
     * Set handle value
     * @param string $handle
     * @return \StructType\Contact
     */
    public function setHandle($handle = null)
    {
        // validation for constraint: string
        if (!is_null($handle) && !is_string($handle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($handle, true), gettype($handle)), __LINE__);
        }
        $this->handle = $handle;
        return $this;
    }
    /**
     * Get civilite value
     * @return string|null
     */
    public function getCivilite()
    {
        return $this->civilite;
    }
    /**
     * Set civilite value
     * @uses \EnumType\TypeCivilite::valueIsValid()
     * @uses \EnumType\TypeCivilite::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $civilite
     * @return \StructType\Contact
     */
    public function setCivilite($civilite = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TypeCivilite::valueIsValid($civilite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TypeCivilite', is_array($civilite) ? implode(', ', $civilite) : var_export($civilite, true), implode(', ', \EnumType\TypeCivilite::getValidValues())), __LINE__);
        }
        $this->civilite = $civilite;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\Contact
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \StructType\Contact
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get org value
     * @return string|null
     */
    public function getOrg()
    {
        return $this->org;
    }
    /**
     * Set org value
     * @param string $org
     * @return \StructType\Contact
     */
    public function setOrg($org = null)
    {
        // validation for constraint: string
        if (!is_null($org) && !is_string($org)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($org, true), gettype($org)), __LINE__);
        }
        $this->org = $org;
        return $this;
    }
    /**
     * Get str1 value
     * @return string|null
     */
    public function getStr1()
    {
        return $this->str1;
    }
    /**
     * Set str1 value
     * @param string $str1
     * @return \StructType\Contact
     */
    public function setStr1($str1 = null)
    {
        // validation for constraint: string
        if (!is_null($str1) && !is_string($str1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($str1, true), gettype($str1)), __LINE__);
        }
        $this->str1 = $str1;
        return $this;
    }
    /**
     * Get str2 value
     * @return string|null
     */
    public function getStr2()
    {
        return $this->str2;
    }
    /**
     * Set str2 value
     * @param string $str2
     * @return \StructType\Contact
     */
    public function setStr2($str2 = null)
    {
        // validation for constraint: string
        if (!is_null($str2) && !is_string($str2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($str2, true), gettype($str2)), __LINE__);
        }
        $this->str2 = $str2;
        return $this;
    }
    /**
     * Get str3 value
     * @return string|null
     */
    public function getStr3()
    {
        return $this->str3;
    }
    /**
     * Set str3 value
     * @param string $str3
     * @return \StructType\Contact
     */
    public function setStr3($str3 = null)
    {
        // validation for constraint: string
        if (!is_null($str3) && !is_string($str3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($str3, true), gettype($str3)), __LINE__);
        }
        $this->str3 = $str3;
        return $this;
    }
    /**
     * Get pc value
     * @return string|null
     */
    public function getPc()
    {
        return $this->pc;
    }
    /**
     * Set pc value
     * @param string $pc
     * @return \StructType\Contact
     */
    public function setPc($pc = null)
    {
        // validation for constraint: string
        if (!is_null($pc) && !is_string($pc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pc, true), gettype($pc)), __LINE__);
        }
        $this->pc = $pc;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\Contact
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get state value
     * @return string|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @param string $state
     * @return \StructType\Contact
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\Contact
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get langue value
     * @return string|null
     */
    public function getLangue()
    {
        return $this->langue;
    }
    /**
     * Set langue value
     * @param string $langue
     * @return \StructType\Contact
     */
    public function setLangue($langue = null)
    {
        // validation for constraint: string
        if (!is_null($langue) && !is_string($langue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($langue, true), gettype($langue)), __LINE__);
        }
        $this->langue = $langue;
        return $this;
    }
    /**
     * Get email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @param string $email
     * @return \StructType\Contact
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Get tel value
     * @return string|null
     */
    public function getTel()
    {
        return $this->tel;
    }
    /**
     * Set tel value
     * @param string $tel
     * @return \StructType\Contact
     */
    public function setTel($tel = null)
    {
        // validation for constraint: string
        if (!is_null($tel) && !is_string($tel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tel, true), gettype($tel)), __LINE__);
        }
        $this->tel = $tel;
        return $this;
    }
    /**
     * Get fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->fax;
    }
    /**
     * Set fax value
     * @param string $fax
     * @return \StructType\Contact
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->fax = $fax;
        return $this;
    }
    /**
     * Get gsm value
     * @return string|null
     */
    public function getGsm()
    {
        return $this->gsm;
    }
    /**
     * Set gsm value
     * @param string $gsm
     * @return \StructType\Contact
     */
    public function setGsm($gsm = null)
    {
        // validation for constraint: string
        if (!is_null($gsm) && !is_string($gsm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gsm, true), gettype($gsm)), __LINE__);
        }
        $this->gsm = $gsm;
        return $this;
    }
    /**
     * Get isowner value
     * @return bool|null
     */
    public function getIsowner()
    {
        return $this->isowner;
    }
    /**
     * Set isowner value
     * @param bool $isowner
     * @return \StructType\Contact
     */
    public function setIsowner($isowner = null)
    {
        // validation for constraint: boolean
        if (!is_null($isowner) && !is_bool($isowner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isowner, true), gettype($isowner)), __LINE__);
        }
        $this->isowner = $isowner;
        return $this;
    }
    /**
     * Get pwd value
     * @return string|null
     */
    public function getPwd()
    {
        return $this->pwd;
    }
    /**
     * Set pwd value
     * @param string $pwd
     * @return \StructType\Contact
     */
    public function setPwd($pwd = null)
    {
        // validation for constraint: string
        if (!is_null($pwd) && !is_string($pwd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pwd, true), gettype($pwd)), __LINE__);
        }
        $this->pwd = $pwd;
        return $this;
    }
    /**
     * Get siret value
     * @return string|null
     */
    public function getSiret()
    {
        return $this->siret;
    }
    /**
     * Set siret value
     * @param string $siret
     * @return \StructType\Contact
     */
    public function setSiret($siret = null)
    {
        // validation for constraint: string
        if (!is_null($siret) && !is_string($siret)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($siret, true), gettype($siret)), __LINE__);
        }
        $this->siret = $siret;
        return $this;
    }
    /**
     * Get metadata value
     * @return string|null
     */
    public function getMetadata()
    {
        return $this->metadata;
    }
    /**
     * Set metadata value
     * @param string $metadata
     * @return \StructType\Contact
     */
    public function setMetadata($metadata = null)
    {
        // validation for constraint: string
        if (!is_null($metadata) && !is_string($metadata)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($metadata, true), gettype($metadata)), __LINE__);
        }
        $this->metadata = $metadata;
        return $this;
    }
}
